Subject: RE: Deployment of Dual Stack with Applications

From: "Bound, Jim" <[email-masked]>
Date: Wed, 12 Feb 2003 13:55:20 -0500

Here is pointer to API paper users are downloading too.
I am traveling now so may not respond to email for my interrupts to the
mail list till next week depending on schedules and stuff.
 
http://www.nav6tf.org/slides/trans_ipv6_v013.pdf
 
/jim

	-----Original Message-----
	From: Bound, Jim 
	Sent: Wednesday, February 12, 2003 1:02 PM
	To: [email-masked]
	Subject: Deployment of Dual Stack with Applications

	Folks,
	 
	First I think the consensus for dual stack is clearly making
head way finally in and out of the IETF.
	 
	But here is a real operational scenario for us I am working on
right now.
	 
	User believe IPv6 is important and they want to deploy.  The
need to worry about all the things we discuss here but there is another
one.  When do they tell their suppliers they MUST support IPv6 and how
does this work?  And when does IPv6 get turned on?
	 
	The good thing about a dual stack approach is these users can
mandate all suppliers must support the dual IPv6/IPv4 stack for
procurement at some specified point in time. But they will most likely
have to run IPv4 intiially on those procured boxes until the v6ops type
parts are figured out and applications are ported.
	 
	Now to the technical issue.
	 
	How are the apps ported and at what point on the suppliers
boxes?
	 
	Using IPv4-Mapped addresses in the base API an app could port to
IPv6 and take IPv6 addresses and IPv4Mapped addresses from getaddrinfo()
(old gethostbyname() for those that don't know getaddrinfo() yet) and
pass down IPv4-Mapped addresses to a dual stack implementation and they
will be put out over the network as IPv4 by a dual stack node, but to
the application layer they are just doing IPv6.
	 
	This will be part of the deployment recommendations from
vendors, consultants, and systems integrators for users and some users
will figure this out on their own and large application software
providers that only want to release one binary for both IPv4 and IPv6.
	 
	I am not sure if we should put this into any docs for v6ops or
not?  It could be viewed as implementation deployment effort and issue
not a standars issue? But it should be part of our emerging scenarios is
my belief currently (all of them)?
	 
	Comments.
	 
	Regards,
	/jim

---

From: Keith Moore <[email-masked]>
Date: Mon, 17 Feb 2003 00:53:18 -0500

> 	How are the apps ported and at what point on the suppliers

there is no simple answer to this question.  but changing the behavior
of existing APIs to try to hide IPv6 from apps will harm interoperability.

the goal should be to facilitate a more capable Internet supporting more
capable apps, not merely to get apps to change packet formats whether they
know about it or not.  apps won't get more capable by being unaware of IPv6.

Keith